﻿// Fill out your copyright notice in the Description page of Project Settings.


#include "GOAPAction.h"

bool UGOAPAction::CheckPreConditions(UWorldState* WorldState)
{
	for (TPair<FString, int> PreCondition : PreConditions)
	{
		if (WorldState->State.Contains(PreCondition.Key))
		{
			if (WorldState->State[PreCondition.Key] < PreCondition.Value) return false;
		}
	}
	return true;
}

UWorldState* UGOAPAction::ApplyEffects(UWorldState* WorldState)
{
	UWorldState* NewWorldState = NewObject<UWorldState>();
	NewWorldState->State.Append(WorldState->State);
	for (TPair<FString, int> Effect : Effects)
	{
		if (NewWorldState->State.Contains(Effect.Key))
		{
			NewWorldState->State[Effect.Key] -= Effect.Value;
		}
	}
	return NewWorldState;
}

int UGOAPAction::Perform()
{
	return Effects["PlayerHealth"];
}
